using Verse;

namespace rjw
{
	[StaticConstructorOnStartup]
	public static class AddComp
	{
		static AddComp()
		{
			AddRJWComp();
		}

		/// <summary>
		/// This automatically adds the comp to all races on startup.
		/// Races that should never be sexualized can be filtered out here, instead of checking them later.
		/// </summary>
		public static void AddRJWComp()
		{
			foreach (ThingDef thingDef in DefDatabase<ThingDef>.AllDefs)
			{
			    // Add filtered races here.
				if (thingDef.race == null )
					continue;

				thingDef.comps.Add(new CompProperties_RJW());
				//Log.Message("Adding def to race " + thingDef.label);
			}
		}
	}
}