using System.Linq;
using RimWorld;
using Verse;
using Verse.AI;
using System.Collections.Generic;

namespace rjw
{
	//Rape to Prisoner of QuestPrisonerWillingToJoin
	class JobGiver_AIRapePrisoner : ThinkNode_JobGiver
	{
		private const float min_fuckability = 0.10f; // Don't rape prisoners with <10% fuckability

		public static Pawn find_victim(Pawn rapist, Map m)
		{
			IEnumerable<Pawn> possible_targets = m.mapPawns.AllPawns.Where(x
				=> IsPrisonerOf(x, rapist.Faction)
				&& x != rapist
				&& xxx.can_get_raped(x)
				&& !x.Position.IsForbidden(rapist)
				);

			List<Pawn> valid_targets = new List<Pawn>();

			foreach (Pawn target in possible_targets)
			{
				if (!rapist.CanReserve(target, xxx.max_rapists_per_prisoner, 0)) continue;

				//--Log.Message(xxx.get_pawnname(rapist) + "->" + xxx.get_pawnname(target) + ":" + fuc);
				if (xxx.would_fuck(rapist, target, true, true) > min_fuckability)
				{
					valid_targets.Add(target);
				}
			}

			return valid_targets.Any() ? valid_targets.RandomElement() : null;
		}

		protected override Job TryGiveJob(Pawn rapist)
		{
			//Log.Message("[RJW] JobGiver_AIRapePrisoner::TryGiveJob( " + xxx.get_pawnname(rapist) + " ) called ");

			if (SexUtility.ReadyForLovin(rapist) || xxx.need_some_sex(rapist) > 1f)
			{
				// don't allow pawns marked as comfort prisoners to rape others
				if (xxx.is_healthy(rapist) && xxx.can_rape(rapist))
				{
					Pawn prisoner = find_victim(rapist, rapist.Map);

					if (prisoner != null)
					{
						//--Log.Message("[RJW] JobGiver_RandomRape::TryGiveJob( " + xxx.get_pawnname(p) + " ) - found victim " + xxx.get_pawnname(prisoner));
						return new Job(xxx.random_rape, prisoner);
					}
				}
			}

			return null;
		}

		protected static bool IsPrisonerOf(Pawn pawn,Faction faction)
		{
			if (pawn?.guest == null) return false;
			return pawn.guest.HostFaction == faction && pawn.guest.IsPrisoner;
		}
	}
}
