using Verse;
using Verse.AI;
using RimWorld;
using System.Collections.Generic;
using System.Linq;

namespace rjw
{
	public class JobGiver_ComfortPrisonerRape : ThinkNode_JobGiver
	{
		public static Pawn find_prisoner_to_rape(Pawn rapist, Map m)
		{
			Pawn best_rapee = null;
			float best_fuckability = 0.10f; // Don't rape prisoners with <10% fuckability
			IEnumerable<Pawn> targets = m.AllComfortDesignations().Where(x
				=> x != rapist
				&& xxx.can_get_raped(x)
				&& rapist.CanReserveAndReach(x, PathEndMode.Touch, Danger.Some, xxx.max_rapists_per_prisoner, 0)
				&& !x.IsForbidden(rapist)
				&& xxx.would_rape(rapist, x)
				);

			if (xxx.is_animal(rapist))
			{
				// Animals only consider targets they can see, instead of seeking them out.
				targets = targets.Where(x => rapist.CanSee(x)).ToList();
			}

			foreach (Pawn target in targets)
			{
				float fuc = 0.0f;
				if (xxx.is_animal(target))
					fuc = xxx.would_fuck_animal(rapist, target, true);
				else if (xxx.is_human(target))
					fuc = xxx.would_fuck(rapist, target, true);
				//--Log.Message(rapist.Name + " -> " + candidate.Name + " (" + fuc.ToString() + " / " + best_fuckability.ToString() + ")");

				if (fuc > best_fuckability)
				{
					best_rapee = target;
					best_fuckability = fuc;
				}
			}
			return best_rapee;
		}

		protected override Job TryGiveJob(Pawn rapist)
		{
			//Log.Message("[RJW] JobGiver_ComfortPrisonerRape::TryGiveJob( " + xxx.get_pawnname(rapist) + " ) called0");

			if (!RJWSettings.WildMode)
			{
				// don't allow pawns marked as comfort prisoners to rape others
				if (!xxx.is_healthy(rapist) || rapist.IsDesignatedComfort() || (!SexUtility.ReadyForLovin(rapist) && !xxx.is_frustrated(rapist))) return null;
			}

			//Log.Message("[RJW] JobGiver_ComfortPrisonerRape::TryGiveJob( " + xxx.get_pawnname(rapist) + " ) called1");
			if (!xxx.can_rape(rapist)) return null;

			// It's unnecessary to include other job checks. Pawns seem to only look for new jobs when between jobs or layind down idle.
			if (!(rapist.jobs.curJob == null || rapist.jobs.curJob.def == JobDefOf.LayDown)) return null;

			//--Log.Message("[RJW] JobGiver_ComfortPrisonerRape::TryGiveJob( " + xxx.get_pawnname(rapist) + " ) called2");
			// Faction check.
			if (!(rapist.Faction?.IsPlayer ?? false) && !rapist.IsPrisonerOfColony) return null;

			Pawn target = find_prisoner_to_rape(rapist, rapist.Map);
			//--Log.Message("[RJW] JobGiver_ComfortPrisonerRape::TryGiveJob( " + xxx.get_pawnname(rapist) + " ) called3 - (" + ((target == null) ? "no target found" : xxx.get_pawnname(target))+") is the prisoner");

			if (target == null) return null;

			//Log.Message("giving job to " + pawner + " with target " + target);
			if (xxx.is_animal(target))
				return new Job(xxx.bestiality, target);
			else
				return new Job(xxx.comfort_prisoner_rapin, target);
		}
	}
}
