using System.Collections.Generic;
using System.Linq;
using RimWorld;
using Verse;
using Verse.AI;

namespace rjw
{
	public class JobGiver_JoinInBed : ThinkNode_JobGiver
	{
		private static bool is_healthy(Pawn target)
		{
			return xxx.is_healthy(target) && (xxx.can_fuck(target) || xxx.can_be_fucked(target));
		}

		private static bool roll_to_skip(Pawn pawn, Pawn target)
		{
			float fuckability = xxx.would_fuck(pawn, target); // 0.0 to 1.0
			if (fuckability < 0.1f) return false;

			float chance_to_skip = 0.9f - 0.7f * fuckability;
			return Rand.Value < chance_to_skip;
		}

		public static Pawn find_pawn_to_fuck(Pawn pawn, Map map)
		{
			Pawn best_fuckee = null;
			float best_distance = 1.0e6f;

			List<Pawn> targets = map.mapPawns.FreeColonists.Where(x 
				=> x.InBed()
				&& x != pawn
				&& !x.Position.IsForbidden(pawn) 
				&& !x.Suspended 
				&& !x.Downed 
				&& is_healthy(x) 
				&& x.Map == pawn.Map 
				&& (xxx.is_laying_down_alone(x) || xxx.in_same_bed(x, pawn))
				).ToList();

			// find lover/partner on same map
			List<Pawn> partners = targets.Where(x 
				=> pawn.relations.DirectRelationExists(PawnRelationDefOf.Lover, x) 
				|| pawn.relations.DirectRelationExists(PawnRelationDefOf.Fiance, x) 
				|| pawn.relations.DirectRelationExists(PawnRelationDefOf.Spouse, x)
				).ToList();

			if (partners.Any())
			{
				partners.Shuffle(); //Randomize order.
				foreach (Pawn target in partners)
				{
					//Log.Message("[RJW] find_pawn_to_fuck( " + xxx.get_pawnname(target) + " ) partner found");
					if (pawn.Position.DistanceToSquared(target.Position) < 100
						&& pawn.CanReserveAndReach(target, PathEndMode.OnCell, Danger.Some, 1, 0)
						&& target.CanReserve(pawn, 1, 0))
						return target;
					//Log.Message("[RJW] find_pawn_to_fuck( " + xxx.get_pawnname(target) + " ) partner cant be fucked right now");
				}
			}

			// No random lovin' for non-nymphos.
			if (!xxx.is_nympho(pawn))
				return null;

			foreach (Pawn q in targets)
			{
				if (pawn.CanReserveAndReach(q, PathEndMode.OnCell, Danger.Some, 1, 0) &&
					q.CanReserve(pawn, 1, 0) &&
					roll_to_skip(pawn, q))
				{
					int dis = pawn.Position.DistanceToSquared(q.Position);
					if (dis < best_distance)
					{
						best_fuckee = q;
						best_distance = dis;
					}
				}
			}
			return best_fuckee;
		}

		protected override Job TryGiveJob(Pawn pawn)
		{
			//--Log.Message("[RJW] JobGiver_JoinInBed( " + xxx.get_pawnname(pawn) + " ) called");

			if (!SexUtility.ReadyForLovin(pawn) && !xxx.is_frustrated(pawn)) return null;

			if (pawn.CurJob == null || pawn.CurJob.def == JobDefOf.LayDown)
			{
				//--Log.Message("   checking pawn and abilities");
				if (xxx.can_fuck(pawn) || xxx.can_be_fucked(pawn))
				{
					//--Log.Message("   finding partner");
					Pawn partner = find_pawn_to_fuck(pawn, pawn.Map);

					//--Log.Message("   checking partner");
					if (partner == null) return null;

					// Can never be null, since find checks for bed.
					Building_Bed bed = partner.CurrentBed();

					// Interrupt current job.
					if (pawn.CurJob != null)
						pawn.jobs.curDriver.EndJobWith(JobCondition.InterruptForced);

					//--Log.Message("   returning job");
					return new Job(DefDatabase<JobDef>.GetNamed("JoinInBed"), pawn, partner, bed);
				}
			}

			return null;
		}
	}
}
