using System.Linq;
using RimWorld;
using Verse;
using Verse.AI;
using System.Collections.Generic;

namespace rjw
{
	public class JobGiver_RandomRape : ThinkNode_JobGiver
	{
		public static Pawn find_victim(Pawn rapist, Map m)
		{
			Pawn victim = null;

			IEnumerable<Pawn> victims = m.mapPawns.AllPawnsSpawned.Where(x 
				=> x != rapist
				&& xxx.is_not_dying(x)
				&& xxx.can_get_raped(x)
				&& !x.Suspended
				&& !x.IsForbidden(rapist)
				&& rapist.CanReserveAndReach(x, PathEndMode.Touch, Danger.Some, xxx.max_rapists_per_prisoner, 0)
				&& !x.HostileTo(rapist)
				);

			float best_fuckability = 0.10f; // Don't rape pawns with <10% fuckability

			//Animal rape
			if (xxx.is_zoophile(rapist) && RJWSettings.bestiality_enabled)
			{
				foreach (var animal in victims.Where(x => xxx.is_animal(x)))
				{
					float fuc = xxx.would_fuck(rapist, animal, true, true);
					if (fuc > best_fuckability)
					{
						best_fuckability = fuc;
						victim = animal;
					}
				}

				if (victim != null)
					return victim;
			}

			// Humanlike rape - could be prisoner, colonist, or non-hostile outsider
			foreach (var human in victims.Where(x => !xxx.is_animal(x)))
			{
				float fuc = xxx.would_fuck(rapist, human, true, true);
				if (fuc > best_fuckability)
				{
					best_fuckability = fuc;
					victim = human;
				}
			}

			return victim;
		}

		protected override Job TryGiveJob(Pawn rapist)
		{
			//Log.Message("[RJW] JobGiver_RandomRape::TryGiveJob( " + xxx.get_pawnname(rapist) + " ) called");
			if (SexUtility.ReadyForLovin(rapist) || xxx.need_some_sex(rapist) > 1f)
			{
				// don't allow pawns marked as comfort prisoners to rape others
				if (xxx.is_healthy_enough(rapist) && xxx.can_rape(rapist))
				{
					Pawn victim = find_victim(rapist, rapist.Map);

					if (victim != null)
					{
						//Log.Message("[RJW] JobGiver_RandomRape::TryGiveJob( " + xxx.get_pawnname(rapist) + " ) - found victim " + xxx.get_pawnname(victim));
						return new Job(xxx.random_rape, victim);
					}
				}
			}

			return null;
		}
	}
}