using RimWorld;
using Verse;
using Verse.AI;
using System.Collections.Generic;
using System.Linq;

namespace rjw
{
	public class JobGiver_ViolateCorpse : ThinkNode_JobGiver
	{
		public static Corpse find_corpse(Pawn rapist, Map m)
		{
			//Log.Message("JobGiver_ViolateCorpse::find_corpse( " + xxx.get_pawnname(rapist) + " ) called");
			Corpse found = null;
			float best_fuckability = 0.1f;

			IEnumerable<Thing> corpses = m.spawnedThings.Where(x 
				=> x is Corpse 
				&& rapist.CanReserveAndReach(x, PathEndMode.OnCell, Danger.Some)
				&& !x.IsForbidden(rapist)
				);

			foreach (Thing thing in corpses)
			{
				// This should stop the job from overcasting into wrong would_fuck method.
				Corpse corpse = (Corpse)thing;

				// Filter out rotters if not necrophile.
				if (!xxx.is_necrophiliac(rapist) && corpse.CurRotDrawMode != RotDrawMode.Fresh)
					continue;

				float fuc = xxx.would_fuck(rapist, corpse, false, false);
				//--Log.Message("   " + xxx.get_pawnname(corpse.Inner) + " =  " + fuc + ",  best =  " + best_fuckability);
				if (!(fuc > best_fuckability)) continue;

				found = corpse;
				best_fuckability = fuc;
			}
			return found;
		}

		protected override Job TryGiveJob(Pawn rapist)
		{
			// Most checks are done in ThinkNode_ConditionalNecro.

			// filter out necro for nymphs
			if (!RJWSettings.necrophilia_enabled) return null;

			//--Log.Message("[RJW] JobGiver_ViolateCorpse::TryGiveJob for ( " + xxx.get_pawnname(rapist) + " )");
			if (SexUtility.ReadyForLovin(rapist) || xxx.need_some_sex(rapist) > 1f)
			{
				//--Log.Message("[RJW] JobGiver_ViolateCorpse::TryGiveJob, can love ");
				if (!xxx.can_rape(rapist)) return null;

				var target = find_corpse(rapist, rapist.Map);
				//--Log.Message("[RJW] JobGiver_ViolateCorpse::TryGiveJob - target is " + (target == null ? "NULL" : "Found"));
				if (target != null)
				{
					return new Job(xxx.violate_corpse, target);
				}
				// Ticks should only be increased after successful sex.
			}

			return null;
		}
	}
}