﻿using System;
using System.Collections.Generic;
using RimWorld;
using Verse;

namespace rjw
{
	public class Recipe_MakeFuta : Recipe_InstallArtificialBodyPart
	{
		public override void ApplyOnPawn(Pawn pawn, BodyPartRecord part, Pawn billDoer, List<Thing> ingredients, Bill bill) {
			GenderHelper.Sex before = GenderHelper.GetSex(pawn);

			if (!base.CheckSurgeryFail(billDoer, pawn, ingredients, part, bill))
			{
				//Log.Message("Recipe_MakeFuta::CheckSurgery( " + xxx.get_pawnname(pawn) + " ) Succsess");
				var heddiff = bill.recipe.addsHediff;
				pawn.health.AddHediff(heddiff, part);
				var recipe = bill.recipe;
				foreach (var item in ingredients)
				{
					if (!item.Destroyed)
						base.ConsumeIngredient(item, recipe, item.Map);
				}
			}
			else
			{
				//Log.Message("Recipe_MakeFuta::CheckSurgery( " + xxx.get_pawnname(pawn) + " ) Fail");
				Messages.Message(xxx.get_pawnname(billDoer) + " failed to keep both parts on " + xxx.get_pawnname(pawn) + ".", MessageTypeDefOf.NegativeHealthEvent);

				//ED86:
				//if enabled - replaces part with new one, old one spawned near
				//if disabled - keeps current part, new one consumed
				//ED86.2:
				//50% to keep existing part, or replace with new part
				//if (Rand.Value < .5f)
				//	base.ApplyOnPawn(pawn, part, billDoer, ingredients, bill);
			}

			GenderHelper.Sex after = GenderHelper.GetSex(pawn);
			GenderHelper.ChangeSex(pawn, before, after);
		}
	}
}