﻿using RimWorld;
using Verse;
using Verse.AI;

namespace rjw
{
	public class WorkGiver_CleanSelf : WorkGiver_Scanner
	{
		public override PathEndMode PathEndMode
		{
			get
			{
				return PathEndMode.InteractionCell;
			}
		}

		public override Danger MaxPathDanger(Pawn pawn)
		{
			return Danger.Deadly;
		}

		public override ThingRequest PotentialWorkThingRequest
		{
			get
			{
				return ThingRequest.ForGroup(ThingRequestGroup.Pawn);
			}
		}

		//conditions for self-cleaning job to be available
		public override bool HasJobOnThing(Pawn pawn, Thing t, bool forced = false)
		{
			Hediff hediff = pawn.health.hediffSet.hediffs.Find(x => (x.def == RJW_HediffDefOf.Hediff_Bukkake));
			int minAge = 3 * 2500;//3 hours in-game must have passed
			if (pawn == t && hediff != null && hediff.ageTicks > minAge && pawn.CanReserve(t, 1, -1, null, forced) && !xxx.DubsBadHygieneIsActive)
			{
				return true;
			}
			return false;
		}

		public override Job JobOnThing(Pawn pawn, Thing t, bool forced = false)
		{
			return new Job(RJW_JobDefOf.CleanSelf);
		}
	}
}
